          *This software come with absolutely no warranty of any kind*

 hrc2gbi - convert SoftImage model files (IE: .hrc) to GBI/display lists. 
    .hrc files should be converted to ascii first using the SI prog:
    hrcConvert binfile.hrc asciifile.hrc -a

  usage:
   hrc2gbi infile.hrc outbasefile 

    generates: 
        outbasefile.c - makes n64 includes, vertex first, followed by model
            dl's (triangles), then "master" dl's - these contain color & 
            texture & matrix info. This allow for instancing models, changing 
            the colors and location in a different "master" dl.
             Note: models vertices include gsSpCull() info in the first 8 verts 
            for auto culling, if off screen (gsSPCull() is generated 
            automatically in model dl) this may create problems if you morph
            your model. (IE: skip first 8 vtx of vtx list)
             Texture mapping with UV's is supported, to gen uv's do:
            Text_oper->info_UV_coord in the material menu of SI.
             For reflection maps, UV's are generated automagically by the N64 
            hardware. Materials affect texture maps by changing the N64 lights
            to be brighter/darker/colo{u}red. The diffuse color affects
            reflections. If diff=255 then you have full rfl, if diff=0 then
            no rfl. this is controled by PrimColor (I think check to make sure)
             Lights in soft are currently ignored. (actually you have to define 
            a light in "master"/master dl.  if no lights are define when the 
            "master" dl is called, then i don't know hwat will happen. 8)

        outbasefile.h - vertex and triangle info - number of verts & tri's for
            each models. This is usefull for morphs and normal tweaking. It
            also contains texture map references for textures encountered
            in the .hrc file. (IE: extern unsigned short texture[];)
            Currently 32x32 5551 textures maps are supported.

        outbasefile_init.c - matrix init code. Simple 'c' routine to call from
            your proggy to init the matrices to what the are in the .hrc file.
            init code call mkmat_srt() which makes a scale,rotate,translate
            matrix in the supplied N64 matrix.
             *Note*
             If you want a matrix auto-generated you *have* to have a value
            that is non-identity. IE: scale != 1.0 or rot != 0.0 or 
            trans !=0.0 *this* is how hrc2gbi determines if a matrix should
            be generated.
             *Note2*
             I *don't* recommend using soft's scale, since i havn't tested to
            see if just changing the order (SRT instead of RTS-rot,tran,scale)
            avoids the SI "classical" vs. "normal" scaling issues. In general:
            freeze all transforms in model effect->freeze->transforms.
            then pick the node (*not* the hierarchy) that you want animated
            and make it a non-zero number. Centers are another issue...
            it doesn't hurt to have extra matrices generated, but there is
            a limit(10 for depth), *and* it costs you when the dl's is 
            rendered.

        outbasefile_init.h - matrix data struct. all the mtx's created for
            outbasefile_init.c wraped in a struct for easy 
            osWritebackDCache() (done in outbasefile.c/master.dl)

    temporary files: you should not see these unless the program craps out.
        they are created & removed by "system()" commands.
        These are generated because the order that things are encountered
        and generated in the program are not how they need to be in the
        .[ch] files. If you want them isolated, remove the "rm" system
        commands from hrc2gbi.c

        outbasefile_tmptri.c - model dl's. the triangle info mainly.
        outbasefile_tmptri.h - texture map declarations, and vertex & triangle
            info (NTri's NVtx's) for the model dl.

        outbasefile_tmpvtx.c - include files for tri & vtx info.

        outbasefile_mtx.c - matrice init "c" code.
        outbasefile_mtx.h - matrice data struct. for mtx.c

        outbasefile_tmpdl.c - model dl's. the triangle info mainly.
        outbasefile_tmpdl.h - texture map declarations, and vertex & triangle
            info (NTri's NVtx's) for the model dl.


    Other stuff:
        The vertex optimization algorithm is as follows:
            seed the 16 point cache with any vertex.
            loop
             foreach point in vertex cache:
              find edges that share any point and aren't cached/outputed
              build point list of above ^
             end
            sort points, and find which occur most.
            add that "best" point to vertex cache.
            if cache is full- empty all points that aren't outputed already.
                output triangles complete by cache points.
            if cache is still full-remove 4 contigous points, based on a 
                counter
            start again.

        I dunno. there are some constants in the prog that should be vars
        but I'm tire of dealing with converters :\

    no more docs,

    This is beerware, if u are in Venice and want to buy me a beer, email
	me and we'll me at the Baja Cantina.

    cya'll
        NaN/Paul

	nan@instanet.com
